/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;namespace PluginIdea.VolumeLight{public static class Noise3D{const HideFlags kHideFlags = HideFlags.HideAndDontSave;const int minShaderLevel = 35;[RuntimeInitializeOnLoadMethod]        static void OnStartUp(){LoadIfNeeded();}public static void LoadIfNeeded(){if (!isSupported) return;if (ms_NoiseTexture == null){ms_NoiseTexture = LoadTexture3D(GlobalConfig.Instance.noise3DDataAssets, GlobalConfig.Instance.noise3DDimensionSize);if(ms_NoiseTexture)                    ms_NoiseTexture.hideFlags = kHideFlags;}Shader.SetGlobalTexture("_VLB_NoiseTex3D", ms_NoiseTexture);Shader.SetGlobalVector("_VLB_NoiseGlobal", GlobalConfig.Instance.globalNoiseParam);}static Texture3D LoadTexture3D(TextAsset textData, int size){if (textData == null){Debug.LogErrorFormat("Fail to open Noise 3D Data");return null;}var bytes = textData.bytes;int dataLen = Mathf.Max(0, size * size * size);if (bytes.Length != dataLen){Debug.LogErrorFormat("Noise 3D Data file has not the proper size{0}x{0}x{0}", size);return null;}var tex = new Texture3D(size, size, size, TextureFormat.Alpha8, false);var colors = new Color[dataLen];for (int i = 0;i < dataLen;++i)                colors[i] = new Color32(0, 0, 0, bytes[i]);tex.SetPixels(colors);tex.Apply();return tex;}public static bool isSupported{get{if (!ms_IsSupportedChecked){ms_IsSupported = SystemInfo.graphicsShaderLevel >= minShaderLevel;if (!ms_IsSupported)                        Debug.LogWarning(isNotSupportedString);ms_IsSupportedChecked = true;}return ms_IsSupported;}}public static bool isProperlyLoaded{get{return ms_NoiseTexture != null;}}public static string isNotSupportedString{get{var str = string.Format("3D Noise requires higher shader capabilities (Shader Model 3.5 / OpenGL ES 3.0), which are not available on the current platform: graphicsShaderLevel (current/required) ={0}/{1}",                    SystemInfo.graphicsShaderLevel,                    minShaderLevel);return str;}}static bool ms_IsSupportedChecked = false;static bool ms_IsSupported = false;static Texture3D ms_NoiseTexture = null;}}