/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;namespace PluginIdea.VolumeLight{public static class MaterialMgr{static readonly UnityEngine.Rendering.BlendMode[] BlendingMode_SrcFactor = new UnityEngine.Rendering.BlendMode[(int)BlendingMode.Count]{UnityEngine.Rendering.BlendMode.One,                           UnityEngine.Rendering.BlendMode.OneMinusDstColor,               UnityEngine.Rendering.BlendMode.SrcAlpha,};static readonly UnityEngine.Rendering.BlendMode[] BlendingMode_DstFactor = new UnityEngine.Rendering.BlendMode[(int)BlendingMode.Count]{UnityEngine.Rendering.BlendMode.One,                           UnityEngine.Rendering.BlendMode.One,                           UnityEngine.Rendering.BlendMode.OneMinusSrcAlpha,};static readonly bool[] BlendingMode_AlphaAsBlack = new bool[(int)BlendingMode.Count]{true,              true,              false,};static int kStaticPropertiesCount = (int)BlendingMode.Count * (int)DepthBlend.Count * (int)ColorGradient.Count * (int)ClippingPlane.Count * (int)ClippingPlane.Count;public class StaticProperties{public int blendingMode;public int noise3D;public int depthBlend;public int colorGradient;public int clippingPlane;public int materialID{get{return (((((                            (int)blendingMode) *                            (int)Noise3D.Count + (int)noise3D) *                            (int)DepthBlend.Count + (int)depthBlend) *                            (int)ColorGradient.Count + (int)colorGradient) *                            (int)ClippingPlane.Count + (int)clippingPlane)                            ;}}public void ApplyToMaterial(Material mat){mat.SetKeywordEnabled("VLB_ALPHA_AS_BLACK", BlendingMode_AlphaAsBlack[(int)blendingMode]);mat.SetInt("_BlendSrc", (int)BlendingMode_SrcFactor[(int)blendingMode]);mat.SetInt("_BlendDst", (int)BlendingMode_DstFactor[(int)blendingMode]);mat.SetKeywordEnabled("VLB_COLOR_GRADIENT_MATRIX_LOW", colorGradient == ColorGradient.MatrixLow);mat.SetKeywordEnabled("VLB_COLOR_GRADIENT_MATRIX_HIGH", colorGradient == ColorGradient.MatrixHigh);mat.SetKeywordEnabled("VLB_DEPTH_BLEND", depthBlend == DepthBlend.On);mat.SetKeywordEnabled("VLB_NOISE_3D", noise3D == Noise3D.On);mat.SetKeywordEnabled("VLB_CLIPPING_PLANE", clippingPlane == ClippingPlane.On);}}public static Material NewMaterial(bool gpuInstanced){var shader = GlobalConfig.Instance.volumeShader;var material = new Material(shader);material.hideFlags = GlobalConfig.ProceduralObjectsHideFlags;material.renderQueue = GlobalConfig.Instance.geoRenderQueue;material.enableInstancing = true;material.SetKeywordEnabled("VLB_GPU_INSTANCING", true);return material;}class MaterialsGroup{public Material[] materials = new Material[kStaticPropertiesCount];}static Hashtable ms_MaterialsGroup = new Hashtable(1);public static Material GetInstancedMaterial(uint groupID, StaticProperties staticProps){MaterialsGroup group = (MaterialsGroup)ms_MaterialsGroup[groupID];if (group == null){group = new MaterialsGroup();ms_MaterialsGroup[groupID] = group;}int matID = staticProps.materialID;var mat = group.materials[matID];if (mat == null){mat = NewMaterial(gpuInstanced:true);if(mat){group.materials[matID] = mat;staticProps.ApplyToMaterial(mat);}}return mat;}public static MaterialPropertyBlock materialPropertyBlock = new MaterialPropertyBlock();public struct BlendingMode{public const int Additive = 0;public const int SoftAdditive = 1;public const int TraditionalTransparency = 2;public const int Count = 3;}public struct Noise3D{public const int Off = 0;public const int On = 1;public const int Count = 2;}public struct DepthBlend{public const int Off = 0;public const int On = 1;public const int Count = 2;}public struct ColorGradient{public const int Off = 0;public const int MatrixLow = 1;public const int MatrixHigh = 2;public const int Count = 3;}public struct ClippingPlane{public const int Off = 0;public const int On = 1;public const int Count = 2;}}}