/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using System.Collections;using System.Collections.Generic;using UnityEngine;namespace PluginIdea.VolumeLight{public static class MeshGenerator{const float minStartRaidus = 0.001f;public static Mesh GenerateConeLengthZ_RadiusAndAngle(float lengthZ, float radiusStart, float coneAngle, int numSides, int numSegments, bool cap, bool doubleSided){var radiusEnd = lengthZ * Mathf.Tan(coneAngle * Mathf.Deg2Rad * 0.5f);return GenerateConeLengthZ_Radius(lengthZ, radiusStart, radiusEnd, numSides, numSegments, cap, doubleSided);}public static Mesh GenerateConeLengthZ_Angle(float lengthZ, float coneAngle, int numSides, int numSegments, bool cap, bool doubleSided){return GenerateConeLengthZ_RadiusAndAngle(lengthZ, 0f, coneAngle, numSides, numSegments, cap, doubleSided);}public static Mesh GenerateConeLengthZ_Radius(float lengthZ, float radiusStart, float radiusEnd, int numSides, int numSegments, bool cap, bool doubleSided){var mesh = new Mesh();bool genCap = false;genCap = cap && radiusStart > 0f;radiusStart = Mathf.Max(radiusStart, minStartRaidus);int vertCountSides = numSides * (numSegments + 2);int vertCountTotal = vertCountSides;if (genCap)                vertCountTotal += numSides + 1;{var vertices = new Vector3[vertCountTotal];for (int i = 0;i < numSides;i++){float angle = 2 * Mathf.PI * i / numSides;float angleCos = Mathf.Cos(angle);float angleSin = Mathf.Sin(angle);for (int seg = 0;seg < numSegments + 2;seg++){float tseg = (float)seg / (numSegments + 1);float radius = Mathf.Lerp(radiusStart, radiusEnd, tseg);vertices[i + seg * numSides] = new Vector3(radius * angleCos, radius * angleSin, tseg * lengthZ);}}if (genCap){int ind = vertCountSides;vertices[ind] = Vector3.zero;ind++;for (int i = 0;i < numSides;i++){float angle = 2 * Mathf.PI * i / numSides;float angleCos = Mathf.Cos(angle);float angleSin = Mathf.Sin(angle);vertices[ind] = new Vector3(radiusStart * angleCos, radiusStart * angleSin, 0f);ind++;}}if (!doubleSided){mesh.vertices = vertices;}else{var vertices2 = new Vector3[vertices.Length * 2];vertices.CopyTo(vertices2, 0);vertices.CopyTo(vertices2, vertices.Length);mesh.vertices = vertices2;}}{var uv = new Vector2[vertCountTotal];int ind = 0;for (int i = 0;i < vertCountSides;i++)                    uv[ind++] = Vector2.zero;if (genCap){for (int i = 0;i < numSides + 1;i++)                        uv[ind++] = new Vector2(1, 0);}if (!doubleSided){mesh.uv = uv;}else{var uv2 = new Vector2[uv.Length * 2];uv.CopyTo(uv2, 0);uv.CopyTo(uv2, uv.Length);for (int i = 0;i < uv.Length;i++){var value = uv2[i + uv.Length];uv2[i + uv.Length] = new Vector2(value.x, 1);}mesh.uv = uv2;}}{int triCountSides = numSides * 2 * Mathf.Max(numSegments + 1, 1);int indCountSides = triCountSides * 3;int indCountTotal = indCountSides;if (genCap)                    indCountTotal += numSides * 3;var indices = new int[indCountTotal];int ind = 0;for (int i = 0;i < numSides;i++){int ip1 = i + 1;if (ip1 == numSides)                        ip1 = 0;for (int k = 0;k < numSegments + 1;++k){var offset = k * numSides;indices[ind++] = offset + i;indices[ind++] = offset + ip1;indices[ind++] = offset + i + numSides;indices[ind++] = offset + ip1 + numSides;indices[ind++] = offset + i + numSides;indices[ind++] = offset + ip1;}}if (genCap){for (int i = 0;i < numSides - 1;i++){indices[ind++] = vertCountSides;indices[ind++] = vertCountSides + i + 2;indices[ind++] = vertCountSides + i + 1;}indices[ind++] = vertCountSides;indices[ind++] = vertCountSides + 1;indices[ind++] = vertCountSides + numSides;}if (!doubleSided){mesh.triangles = indices;}else{var indices2 = new int[indices.Length * 2];indices.CopyTo(indices2, 0);for (int i = 0;i < indices.Length;i += 3){indices2[indices.Length + i + 0] = indices[i + 0] + vertCountTotal;indices2[indices.Length + i + 1] = indices[i + 2] + vertCountTotal;indices2[indices.Length + i + 2] = indices[i + 1] + vertCountTotal;}mesh.triangles = indices2;}}var bounds = new Bounds(                new Vector3(0, 0, lengthZ * 0.5f),                new Vector3(Mathf.Max(radiusStart, radiusEnd) * 2, Mathf.Max(radiusStart, radiusEnd) * 2, lengthZ)                );mesh.bounds = bounds;return mesh;}static int currentMeshSides;public static Mesh Get(int meshSides){var needDoubleSided = GlobalConfig.Instance.useSinglePassShader;if (ms_Mesh == null                || currentMeshSides != meshSides                || ms_DoubleSided != needDoubleSided){Destroy();ms_Mesh = MeshGenerator.GenerateConeLengthZ_Radius(                    lengthZ: 1f,                    radiusStart: 1f,                    radiusEnd: 1f,                    numSides: meshSides,                    numSegments: GlobalConfig.Instance.sharedMeshSegments,                    cap: true,                    doubleSided: needDoubleSided);ms_Mesh.hideFlags = GlobalConfig.ProceduralObjectsHideFlags;ms_DoubleSided = needDoubleSided;currentMeshSides = meshSides;}return ms_Mesh;}public static void Destroy(){if (ms_Mesh != null){GameObject.DestroyImmediate(ms_Mesh);ms_Mesh = null;}}static Mesh ms_Mesh = null;static bool ms_DoubleSided = false;}}