/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;namespace PluginIdea.VolumeLight{public class VolumetricDust : MonoBehaviour{public Camera mainCamera{get{if (!ms_MainCamera){ms_MainCamera = Utils.CenterCamera;if (!ms_MainCamera && !ms_NoMainCameraLogged){Debug.LogErrorFormat(gameObject, "In order to use 'VolumetricDustParticles' culling, you must have a MainCamera defined in your scene.");ms_NoMainCameraLogged = true;}}return ms_MainCamera;}}static bool ms_NoMainCameraLogged = false;static Camera ms_MainCamera = null;VolumetricLightMono m_Master = null;void Start(){isCulled = false;m_Master = GetComponent<VolumetricLightMono>();InstantiateParticleSystem();SetActiveAndPlay();}void InstantiateParticleSystem(){var slavers = GetComponentsInChildren<ParticleSystem>(true);if (slavers.Length > 0)                for (int i = slavers.Length - 1;i >= 0;--i)                    if (slavers[i].gameObject != gameObject) DestroyImmediate(slavers[i].gameObject);m_Particles = GlobalConfig.Instance.CreateVolumetricDustParticles();if (m_Particles){Debug.Log(m_Particles.transform.name);m_Particles.transform.SetParent(transform, false);m_Renderer = m_Particles.GetComponent<ParticleSystemRenderer>();}}void OnEnable(){SetActiveAndPlay();}void SetActiveAndPlay(){if (m_Particles){m_Particles.gameObject.SetActive(true);SetParticleProperties();m_Particles.Play(true);}}void OnDisable(){if (m_Particles) m_Particles.gameObject.SetActive(false);}void OnDestroy(){if (m_Particles) DestroyImmediate(m_Particles.gameObject);m_Particles = null;}void Update(){if (Application.isPlaying)                UpdateCulling();SetParticleProperties();}void SetParticleProperties(){if (m_Particles && m_Particles.gameObject.activeSelf){var thickness = Mathf.Clamp01(1 - (m_Master.fresnelPow / GlobalConfig.FresnelPowMaxValue));var coneLength = m_Master.fadeEnd * spawnMaxDistance;var ratePerSec = coneLength * density;int maxParticles = (int)(ratePerSec * 4);var main = m_Particles.main;var startLifetime = main.startLifetime;startLifetime.mode = ParticleSystemCurveMode.TwoConstants;startLifetime.constantMin = 4f;startLifetime.constantMax = 6f;main.startLifetime = startLifetime;var startSize = main.startSize;startSize.mode = ParticleSystemCurveMode.TwoConstants;startSize.constantMin = size * 0.9f;startSize.constantMax = size * 1.1f;main.startSize = startSize;var startColor = main.startColor;if (m_Master.colorMode == ColorMode.Flat){startColor.mode = ParticleSystemGradientMode.Color;var colorMax = m_Master.color;colorMax.a *= alpha;startColor.color = colorMax;}else{startColor.mode = ParticleSystemGradientMode.Gradient;var gradientRef = m_Master.colorGradient;var colorKeys = gradientRef.colorKeys;var alphaKeys = gradientRef.alphaKeys;for (int i = 0;i < alphaKeys.Length;++i)                        alphaKeys[i].alpha *= alpha;var newGradient = new Gradient();newGradient.SetKeys(colorKeys, alphaKeys);startColor.gradient = newGradient;}main.startColor = startColor;var startSpeed = main.startSpeed;startSpeed.constant = speed;main.startSpeed = startSpeed;main.maxParticles = maxParticles;var shape = m_Particles.shape;shape.shapeType = ParticleSystemShapeType.ConeVolume;shape.radius = m_Master.coneRadiusStart * Mathf.Lerp(0.3f, 1f, thickness);shape.angle = m_Master.coneAngle * 0.5f * Mathf.Lerp(0.7f, 1f, thickness);shape.length = coneLength;shape.arc = 360f;shape.randomDirectionAmount = (direction == Direction.Random) ? 1f : 0f;var emission = m_Particles.emission;var rate = emission.rateOverTime;rate.constant = ratePerSec;emission.rateOverTime = rate;if (m_Renderer){m_Renderer.sortingLayerID = m_Master.sortingLayerID;m_Renderer.sortingOrder = m_Master.sortingOrder;}}}void UpdateCulling(){if (m_Particles){bool visible = true;if (cullingEnabled && m_Master.hasGeometry){if (mainCamera){var maxDistSqr = cullingMaxDistance * cullingMaxDistance;var distSqr = m_Master.bounds.SqrDistance(mainCamera.transform.position);visible = distSqr <= maxDistSqr;}else                        cullingEnabled = false;}if (m_Particles.gameObject.activeSelf != visible){m_Particles.gameObject.SetActive(visible);isCulled = !visible;}if (visible && !m_Particles.isPlaying)                    m_Particles.Play();}}public float alpha = 0.5f;public float size = 0.01f;public struct Direction{public const int Beam = 0;public const int Random = 1;};public int direction = Direction.Random;public float speed = 0.03f;public float density = 5f;public float spawnMaxDistance = 0.7f;public bool cullingEnabled = true;public float cullingMaxDistance = 10f;public bool isCulled{get;private set;}public static bool isFeatureSupported = true;public bool particlesAreInstantiated{get{return m_Particles;}}public int particlesCurrentCount{get{return m_Particles ? m_Particles.particleCount : 0;}}public int particlesMaxCount{get{return m_Particles ? m_Particles.main.maxParticles : 0;}}ParticleSystem m_Particles = null;ParticleSystemRenderer m_Renderer = null;}}