/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;namespace PluginIdea.VolumeLight{public class VolumetricLightMono : MonoBehaviour{public int meshSides = 40;public bool IsLightbeamEnable{set{if (volumeGeo) volumeGeo.gameObject.SetActive(value);}}public int sortingLayerID{get{return _SortingLayerID;}set{_SortingLayerID = value;if (volumeGeo) volumeGeo.sortingLayerID = value;}}public string sortingLayerName{get{return SortingLayer.IDToName(sortingLayerID);}set{sortingLayerID = SortingLayer.NameToID(value);}}public int sortingOrder{get{return _SortingOrder;}set{_SortingOrder = value;if (volumeGeo) volumeGeo.sortingOrder = value;}}public bool isRealTime{get{return _isRealTime;}set{_isRealTime = value;StartPlaytimeUpdateIfNeeded();}}public bool hasGeometry{get{return volumeGeo != null;}}public Bounds bounds{get{return volumeGeo != null ? volumeGeo.meshRenderer.bounds : new Bounds(Vector3.zero, Vector3.zero);}}public int blendingModeAsInt{get{return Mathf.Clamp((int)blendingMode, 0, System.Enum.GetValues(typeof(BlendingMode)).Length);}}[SerializeField] bool _isRealTime = false;[SerializeField] int _SortingLayerID = 0;[SerializeField] int _SortingOrder = 0;public uint _INTERNAL_InstancedMaterialGroupID{get;protected set;}VLGeometry volumeGeo = null;Coroutine m_CoPlaytimeUpdate = null;public int meshVerticesCount{get{return (volumeGeo && volumeGeo.coneMesh) ? volumeGeo.coneMesh.vertexCount : 0;}}public int meshTrianglesCount{get{return (volumeGeo && volumeGeo.coneMesh) ? volumeGeo.coneMesh.triangles.Length / 3 : 0;}}Light _CachedLight = null;Light lightSpotAttached{get{if(_CachedLight == null) _CachedLight = GetComponent<Light>();if (_CachedLight && _CachedLight.type == LightType.Spot) return _CachedLight;return null;}}public float GetInsideBeamFactor(Vector3 posWS){return GetInsideBeamFactorFromObjectSpacePos(transform.InverseTransformPoint(posWS));}public float GetInsideBeamFactorFromObjectSpacePos(Vector3 posOS){if (posOS.z < 0f) return -1f;var triangle2D = new Vector2(posOS.xy().magnitude, posOS.z + coneApexOffsetZ).normalized;const float maxRadiansDiff = 0.1f;float slopeRad = (coneAngle * Mathf.Deg2Rad) / 2;return Mathf.Clamp((Mathf.Abs(Mathf.Sin(slopeRad)) - Mathf.Abs(triangle2D.x)) / maxRadiansDiff, -1, 1);}public virtual void GenerateGeometry(){ValidateProperties();if (volumeGeo == null){volumeGeo = Utils.NewWithComponent<VLGeometry>("Beam Geometry");volumeGeo.Initialize(this);}volumeGeo.RegenerateMesh(meshSides);volumeGeo.visible = enabled;}public virtual void UpdateAfterManualPropertyChange(){ValidateProperties();if (volumeGeo) volumeGeo.UpdateMaterialAndBounds();}void Start(){GenerateGeometry();}void OnEnable(){if (volumeGeo) volumeGeo.visible = true;StartPlaytimeUpdateIfNeeded();}void OnDisable(){if (volumeGeo) volumeGeo.visible = false;m_CoPlaytimeUpdate = null;}void StartPlaytimeUpdateIfNeeded(){if (Application.isPlaying && isRealTime && m_CoPlaytimeUpdate == null){m_CoPlaytimeUpdate = StartCoroutine(CoPlaytimeUpdate());}}IEnumerator CoPlaytimeUpdate(){while (isRealTime && enabled){UpdateAfterManualPropertyChange();yield return null;}m_CoPlaytimeUpdate = null;}void OnDestroy(){DestroyBeam();}void DestroyBeam(){if (volumeGeo) DestroyImmediate(volumeGeo.gameObject);volumeGeo = null;}void AssignPropertiesFromSpotLight(Light lightSpot){if (lightSpot && lightSpot.type == LightType.Spot){if (fadeEndFromLight) fadeEnd = lightSpot.range;if (alphaFromLightIntensity){alphaInside = alphaOutside = lightSpot.intensity * alphaMultiper;}if (spotAngleFromLight) spotAngle = lightSpot.spotAngle;if (colorFromLight){colorMode = ColorMode.Flat;color = lightSpot.color;}}}void ClampProperties(){alphaInside = Mathf.Clamp01(alphaInside);alphaOutside = Mathf.Clamp01(alphaOutside);attenuationCustomBlending = Mathf.Clamp01(attenuationCustomBlending);fadeEnd = Mathf.Max(GlobalConfig.FadeMinThreshold, fadeEnd);fadeStart = Mathf.Clamp(fadeStart, 0f, fadeEnd - GlobalConfig.FadeMinThreshold);spotAngle = Mathf.Clamp(spotAngle, GlobalConfig.SpotAngleMin, GlobalConfig.SpotAngleMax);coneRadiusStart = Mathf.Max(coneRadiusStart, 0f);depthBlendDistance = Mathf.Max(depthBlendDistance, 0f);cameraClippingDistance = Mathf.Max(cameraClippingDistance, 0f);geomCustomSides = Mathf.Clamp(geomCustomSides, GlobalConfig.GeomSidesMin, GlobalConfig.GeomSidesMax);geomCustomSegments = Mathf.Clamp(geomCustomSegments, GlobalConfig.GeomSegmentsMin, GlobalConfig.GeomSegmentsMax);fresnelPow = Mathf.Max(0f, fresnelPow);glareBehind = Mathf.Clamp01(glareBehind);glareFrontal = Mathf.Clamp01(glareFrontal);noiseIntensity = Mathf.Clamp(noiseIntensity, GlobalConfig.NoiseIntensityMin, GlobalConfig.NoiseIntensityMax);}void ValidateProperties(){AssignPropertiesFromSpotLight(lightSpotAttached);ClampProperties();}public bool colorFromLight = false;public int colorMode = GlobalConfig.ColorModeDefault;public Color color = GlobalConfig.FlatColor;public float intensityMul = 1;public float intensity = 1;public Gradient colorGradient;public float alphaInside = GlobalConfig.Alpha;public float alphaMultiper = 1f;public float alphaOutside = GlobalConfig.Alpha;public int blendingMode = GlobalConfig.BlendingModeDefault;public bool spotAngleFromLight = false;public float spotAngle = GlobalConfig.DefaultSpotAngle;public float coneAngle{get{return Mathf.Atan2(coneRadiusEnd - coneRadiusStart, fadeEnd) * Mathf.Rad2Deg * 2f;}}public float coneRadiusStart = GlobalConfig.ConeRadiusStart;public float coneRadiusEnd{get{return fadeEnd * Mathf.Tan(spotAngle * Mathf.Deg2Rad * 0.5f);}}public float coneVolume{get{float r1 = coneRadiusStart, r2 = coneRadiusEnd;return (Mathf.PI / 3) * (r1 * r1 + r1 * r2 + r2 * r2) * fadeEnd;}}public float coneApexOffsetZ{get{float ratioRadius = coneRadiusStart / coneRadiusEnd;return ratioRadius == 1f ? float.MaxValue : ((fadeEnd * ratioRadius) / (1 - ratioRadius));}}public int geomMeshType = GlobalConfig.GeomMeshType;public int geomCustomSides = GlobalConfig.GeomSidesDefault;public int geomCustomSegments = GlobalConfig.GeomSegmentsDefault;public bool geomCap = GlobalConfig.GeomCap;public bool alphaFromLightIntensity = false;public bool fadeEndFromLight = false;public int attenuationEquation = GlobalConfig.AttenuationEquationDefault;public float attenuationCustomBlending = GlobalConfig.AttenuationCustomBlending;public float attenuationLerpLinearQuad{get{if (attenuationEquation == AttenuationEquation.Linear) return 0f;else if (attenuationEquation == AttenuationEquation.Quadratic) return 1f;return attenuationCustomBlending;}}public float fadeStart = GlobalConfig.FadeStart;public float fadeEnd = GlobalConfig.FadeEnd;public float depthBlendDistance = GlobalConfig.DepthBlendDistance;public float cameraClippingDistance = GlobalConfig.CameraClippingDistance;public float glareFrontal = GlobalConfig.GlareFrontal;public float glareBehind = GlobalConfig.GlareBehind;public float fresnelPow = GlobalConfig.FresnelPow;public bool noiseEnabled = false;public float noiseIntensity = GlobalConfig.NoiseIntensityDefault;public bool noiseScaleUseGlobal = false;public float noiseScaleLocal = GlobalConfig.NoiseScaleDefault;public bool noiseVelocityUseGlobal = false;public Vector3 noiseVelocityLocal = GlobalConfig.NoiseVelocityDefault;}}